﻿--[[	PlayerZoneOptions.lua is part of PlayerZone AddOn (Ver: 2.1009.322b).
	This was programmed by Yulemath
	Mail me at yulemath@hotmail.fr for questions
	This programm is free, you can modify it if you want
	Have fun ;)
	
--]]
function PlayerZone_SetupSlider(self, text, myMin, myMax, step)
	getglobal(self:GetName().."Text"):SetText(text);
	getglobal(self:GetName().."Low"):SetText(myMin);
	getglobal(self:GetName().."High"):SetText(myMax);
	self:SetMinMaxValues(myMin, myMax);
	self:SetValueStep(step)
end

function PlayerZone_Options_Init()
	PlayerZone_Options_Frame_ShowBox:SetChecked(PlayerZone_Options.show);
	PlayerZone_Options_Frame_LockBox:SetChecked(PlayerZone_Options.lock);
	PlayerZone_Options_Frame_TooltipBox:SetChecked(PlayerZone_Options.tooltip);
	PlayerZone_Options_Frame_WorldMapBox:SetChecked(PlayerZone_Options.worldmap);
	PlayerZone_Options_Frame_PluginBox:SetChecked(PlayerZone_Options.plugin);
	PlayerZone_Options_Frame_LevelZoneBox:SetChecked(PlayerZone_Options.levelZone);
	PlayerZone_Options_Frame_LMShowBox:SetChecked(PlayerZone_Options.showLM);
	PlayerZone_Options_Frame_AlphaSlider:SetValue(PlayerZone_Options.alpha);
	PlayerZone_Options_Frame_RedSlider:SetValue(PlayerZone_Options.red);
	PlayerZone_Options_Frame_GreenSlider:SetValue(PlayerZone_Options.green);
	PlayerZone_Options_Frame_BlueSlider:SetValue(PlayerZone_Options.blue);
	PlayerZone_Options_Frame_PluginAnchor:SetValue(PlayerZone_Options.position);
	PlayerZonePlugin_Update();
end

function PlayerZone_Disable()
	if ( not PlayerZone_Options.disable ) then
		PlayerZone_Message(PLAYERZONE_DISABLE);
		DisableAddOn("PlayerZone");
		ReloadUI();
	end
end

function PlayerZoneDisable_OnEnter(self)
	if ( PlayerZone_Options.tooltip ) then
		GameTooltip_SetDefaultAnchor(GameTooltip, self);
		GameTooltip:AddLine(PLAYERZONE_OPTIONS_DISABLE);
		GameTooltip:Show();
	end
end

function PlayerZoneCommands_OnEnter(self)
	if ( PlayerZone_Options.tooltip ) then
		GameTooltip_SetDefaultAnchor(GameTooltip, self);
		GameTooltip:AddLine(PLAYERZONE_COMMANDS);
		GameTooltip:Show();
	end
end

function PlayerZoneMapLevel_Toggle()
	if ( InfoZoneFrame:IsShown() ) then
		InfoZoneFrame:Hide();
		PlayerZone_Options.showLM = false;
	else
		InfoZoneFrame:Show();
		PlayerZone_Options.showLM = true;
	end
end

function PlayerZoneDefault_OnEnter(self)
	if ( PlayerZone_Options.tooltip ) then
		GameTooltip_SetDefaultAnchor(GameTooltip, self);
		GameTooltip:AddLine(PLAYERZONE_DEFAULT);
		GameTooltip:Show();
	end
end

function PlayerZone_DefaultOptions()
	PlayerZone_Options = {
	show = true,
	lock = false,
	tooltip = true,
	worldmap = true,
	levelZone = true,
	plugin = true,
	alpha = 1,
	red = 1,
	green = 1,
	blue = 1,
	disable = false,
	showLM = true,
	position = 1,
};
	PlayerZone_Options_Init();
end

function PlayerZonePlugin_Update()

			PlayerZoneButtonFrame:SetPoint(
		"TOPLEFT",
		"Minimap",
		"TOPLEFT",
		54 - (78 * cos(PlayerZone_Options.position)),
		(78 * sin(PlayerZone_Options.position)) - 55
	);
end

function PZ_Disable_Confirm_Frame()

--Creation de la Fenêtre

PZ_Disable_Confirm_Frame = CreateFrame("Frame", "", UIparent);
PZ_Disable_Confirm_Frame:SetClampedToScreen( true )
PZ_Disable_Confirm_Frame:SetMovable(true);
PZ_Disable_Confirm_Frame:SetFrameStrata("HIGH");
PZ_Disable_Confirm_Frame:SetWidth(250);
PZ_Disable_Confirm_Frame:SetHeight(90);
PZ_Disable_Confirm_Frame:EnableMouse(true);
PZ_Disable_Confirm_Frame:EnableMouseWheel(true);

PZ_Disable_Confirm_Frame:SetBackdrop( { 
  bgFile = "Interface\\Tooltips\\Ui-Tooltip-Background.blp", 
  edgeFile = "Interface\\Minimap\\TooltipBackdrop.blp", tile = false, tileSize = 0, edgeSize = 16, 
  insets = { left = 4, right = 4, top = 4, bottom = 4 }
});

PZ_Disable_Confirm_Frame:SetBackdropColor(0, 0, 0, 0.8);
PZ_Disable_Confirm_Frame:SetPoint("CENTER", 0, 150);

-- Ajout FontString
local pzcf_fs1 = PZ_Disable_Confirm_Frame:CreateFontString("" ,"OVERLAY" ,"GameFontHighlight");
pzcf_fs1:SetText("Souhaitez-vous réellement désactiver PlayerZone?");
pzcf_fs1:SetWidth(230);
pzcf_fs1:SetPoint("TOP", 0, -10);


local pzcf_fs2 = PZ_Disable_Confirm_Frame:CreateFontString("" ,"OVERLAY" ,"GameFontHighlight");
pzcf_fs2:SetText("(Rechargement UI requis)");
pzcf_fs2:SetWidth(230);
pzcf_fs2:SetPoint("TOP", 0, -40);

--Création des boutons

local pzcf_yesButton = CreateFrame("Button", "", PZ_Disable_Confirm_Frame, "OptionsButtonTemplate");
pzcf_yesButton:SetText("Oui");
pzcf_yesButton:SetPoint("BOTTOMLEFT", 10, 10);
pzcf_yesButton:SetScript("OnClick", function()
	PlaySound("magickclick")
	PlayerZone_Disable()
end);

local pzcf_noButton = CreateFrame("Button", "", PZ_Disable_Confirm_Frame, "OptionsButtonTemplate");
pzcf_noButton:SetText("Non");
pzcf_noButton:SetPoint("BOTTOMRIGHT", -10, 10);
pzcf_noButton:SetScript("OnClick", function()
	PZ_Disable_Confirm_Frame:Hide()
end);
end

function PZCFrame_Toggle()

	if ( PZ_Disable_Confirm_Frame:IsShown() ) then
		return;
	else
		PZ_Disable_Confirm_Frame:Show();
		PlaySound("iUIMainMenuButtonA");
		PlayerZone_Options_Frame:Hide();
	end
end
